Package org.opencv.ximgproc

## Class RidgeDetectionFilter

- java.lang.Object
- - org.opencv.core.Algorithm
  - - org.opencv.ximgproc.RidgeDetectionFilter

-     public class RidgeDetectionFilter
      extends Algorithm

  Applies Ridge Detection Filter to an input image. Implements Ridge detection similar to the one in [Mathematica](http://reference.wolfram.com/language/ref/RidgeFilter.html) using the eigen values from the Hessian Matrix of the input image using Sobel Derivatives. Additional refinement can be done using Skeletonization and Binarization. Adapted from CITE: segleafvein and CITE: M_RF

- - ### Field Summary

    - ### Fields inherited from class org.opencv.core.Algorithm

      `nativeObj`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `RidgeDetectionFilter​(long addr)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static RidgeDetectionFilter` | `__fromPtr__​(long addr)` |
    `static RidgeDetectionFilter` | `create()` | Create pointer to the Ridge detection filter.
    `static RidgeDetectionFilter` | `create​(int ddepth)` | Create pointer to the Ridge detection filter.
    `static RidgeDetectionFilter` | `create​(int ddepth, int dx)` | Create pointer to the Ridge detection filter.
    `static RidgeDetectionFilter` | `create​(int ddepth, int dx, int dy)` | Create pointer to the Ridge detection filter.
    `static RidgeDetectionFilter` | `create​(int ddepth, int dx, int dy, int ksize)` | Create pointer to the Ridge detection filter.
    `static RidgeDetectionFilter` | `create​(int ddepth, int dx, int dy, int ksize, int out_dtype)` | Create pointer to the Ridge detection filter.
    `static RidgeDetectionFilter` | `create​(int ddepth, int dx, int dy, int ksize, int out_dtype, double scale)` | Create pointer to the Ridge detection filter.
    `static RidgeDetectionFilter` | `create​(int ddepth, int dx, int dy, int ksize, int out_dtype, double scale, double delta)` | Create pointer to the Ridge detection filter.
    `static RidgeDetectionFilter` | `create​(int ddepth, int dx, int dy, int ksize, int out_dtype, double scale, double delta, int borderType)` | Create pointer to the Ridge detection filter.
    `protected void` | `finalize()` |
    `void` | `getRidgeFilteredImage​(Mat _img, Mat out)` | Apply Ridge detection filter on input image.

    - ### Methods inherited from class org.opencv.core.Algorithm

      `clear, empty, getDefaultName, getNativeObjAddr, save`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### RidgeDetectionFilter

          protected RidgeDetectionFilter​(long addr)

  - ### Method Detail

    - #### __fromPtr__

          public static RidgeDetectionFilter __fromPtr__​(long addr)

    - #### create

          public static RidgeDetectionFilter create​(int ddepth,
                                                    int dx,
                                                    int dy,
                                                    int ksize,
                                                    int out_dtype,
                                                    double scale,
                                                    double delta,
                                                    int borderType)

      Create pointer to the Ridge detection filter.
      Parameters:
        `ddepth` - Specifies output image depth. Defualt is CV_32FC1
        `dx` - Order of derivative x, default is 1
        `dy` - Order of derivative y, default is 1
        `ksize` - Sobel kernel size , default is 3
        `out_dtype` - Converted format for output, default is CV_8UC1
        `scale` - Optional scale value for derivative values, default is 1
        `delta` - Optional bias added to output, default is 0
        `borderType` - Pixel extrapolation method, default is BORDER_DEFAULT SEE: Sobel, threshold, getStructuringElement, morphologyEx.( for additional refinement)
      Returns:
        automatically generated

    - #### create

          public static RidgeDetectionFilter create​(int ddepth,
                                                    int dx,
                                                    int dy,
                                                    int ksize,
                                                    int out_dtype,
                                                    double scale,
                                                    double delta)

      Create pointer to the Ridge detection filter.
      Parameters:
        `ddepth` - Specifies output image depth. Defualt is CV_32FC1
        `dx` - Order of derivative x, default is 1
        `dy` - Order of derivative y, default is 1
        `ksize` - Sobel kernel size , default is 3
        `out_dtype` - Converted format for output, default is CV_8UC1
        `scale` - Optional scale value for derivative values, default is 1
        `delta` - Optional bias added to output, default is 0 SEE: Sobel, threshold, getStructuringElement, morphologyEx.( for additional refinement)
      Returns:
        automatically generated

    - #### create

          public static RidgeDetectionFilter create​(int ddepth,
                                                    int dx,
                                                    int dy,
                                                    int ksize,
                                                    int out_dtype,
                                                    double scale)

      Create pointer to the Ridge detection filter.
      Parameters:
        `ddepth` - Specifies output image depth. Defualt is CV_32FC1
        `dx` - Order of derivative x, default is 1
        `dy` - Order of derivative y, default is 1
        `ksize` - Sobel kernel size , default is 3
        `out_dtype` - Converted format for output, default is CV_8UC1
        `scale` - Optional scale value for derivative values, default is 1 SEE: Sobel, threshold, getStructuringElement, morphologyEx.( for additional refinement)
      Returns:
        automatically generated

    - #### create

          public static RidgeDetectionFilter create​(int ddepth,
                                                    int dx,
                                                    int dy,
                                                    int ksize,
                                                    int out_dtype)

      Create pointer to the Ridge detection filter.
      Parameters:
        `ddepth` - Specifies output image depth. Defualt is CV_32FC1
        `dx` - Order of derivative x, default is 1
        `dy` - Order of derivative y, default is 1
        `ksize` - Sobel kernel size , default is 3
        `out_dtype` - Converted format for output, default is CV_8UC1 SEE: Sobel, threshold, getStructuringElement, morphologyEx.( for additional refinement)
      Returns:
        automatically generated

    - #### create

          public static RidgeDetectionFilter create​(int ddepth,
                                                    int dx,
                                                    int dy,
                                                    int ksize)

      Create pointer to the Ridge detection filter.
      Parameters:
        `ddepth` - Specifies output image depth. Defualt is CV_32FC1
        `dx` - Order of derivative x, default is 1
        `dy` - Order of derivative y, default is 1
        `ksize` - Sobel kernel size , default is 3 SEE: Sobel, threshold, getStructuringElement, morphologyEx.( for additional refinement)
      Returns:
        automatically generated

    - #### create

          public static RidgeDetectionFilter create​(int ddepth,
                                                    int dx,
                                                    int dy)

      Create pointer to the Ridge detection filter.
      Parameters:
        `ddepth` - Specifies output image depth. Defualt is CV_32FC1
        `dx` - Order of derivative x, default is 1
        `dy` - Order of derivative y, default is 1 SEE: Sobel, threshold, getStructuringElement, morphologyEx.( for additional refinement)
      Returns:
        automatically generated

    - #### create

          public static RidgeDetectionFilter create​(int ddepth,
                                                    int dx)

      Create pointer to the Ridge detection filter.
      Parameters:
        `ddepth` - Specifies output image depth. Defualt is CV_32FC1
        `dx` - Order of derivative x, default is 1 SEE: Sobel, threshold, getStructuringElement, morphologyEx.( for additional refinement)
      Returns:
        automatically generated

    - #### create

          public static RidgeDetectionFilter create​(int ddepth)

      Create pointer to the Ridge detection filter.
      Parameters:
        `ddepth` - Specifies output image depth. Defualt is CV_32FC1 SEE: Sobel, threshold, getStructuringElement, morphologyEx.( for additional refinement)
      Returns:
        automatically generated

    - #### create

          public static RidgeDetectionFilter create()

      Create pointer to the Ridge detection filter. SEE: Sobel, threshold, getStructuringElement, morphologyEx.( for additional refinement)
      Returns:
        automatically generated

    - #### getRidgeFilteredImage

          public void getRidgeFilteredImage​(Mat _img,
                                            Mat out)

      Apply Ridge detection filter on input image.
      Parameters:
        `_img` - InputArray as supported by Sobel. img can be 1-Channel or 3-Channels.
        `out` - OutputAray of structure as RidgeDetectionFilter::ddepth. Output image with ridges.

    - #### finalize

          protected void finalize()
                           throws java.lang.Throwable

      Overrides:
        `finalize` in class `Algorithm`
      Throws:
        `java.lang.Throwable`